##  Using RUNSTER Py template, version of 12/09/2016 :
##  rule written by pear.py ;
##  derived from ``;
##  generated on ``;
##  dumped on ``.
##
beag_gold = 5.0 ** 0.5 * 0.5 + 0.5  ##  global

import  math  ##  math library called upon

##  helper functions :
def beag_bool (v):
	##  ensures same bool/math treatment as in Beagle :
	return  (v > 0) + 0
	
def beag_exor (v1,v2):
	##  exclusive or, as in Beagle :
	return  ((v1>0) != (v2>0))

def beag_root(v):
	##  safe square root :
	if v >= 0.0:
		return  math.sqrt(v)
	else:
		return  -math.sqrt(abs(v))

def beag_slog (v):
	##  safe natural logarithm :
	if v < 0:
		return -math.log1p(abs(v))
	else:
		return  math.log1p(v)

def runster_stabprep ():
	##  sets up fallout table :
	stab = {}
	
	##  unpacks stab lines.
	
	return (stab)
	##  stabprep ends.

	
def runster_regrule (vals,stab):
	##  input vals should be an object with appropriate attribute names.
	##  target : ``.
	##  rule mode is ``.

	bins = ['0','1']  ##  omit if demonic
	##  dump catlist.
	##  dump priorvec.
	##  dump subrules.
	##  compute rule values :

	p = 0 ; b = []
	while (p < subrules):
		v = (rule[p] > 0) + 0  ##  ensure numeric, omit if standard
		v = rule[p]  ##  omit if tabular
		b.append(bins[v])  ##  boolean string, omit if standard
		b = ['0']  ##  omit if tabular
		p = p + 1  ##  early-r, late-py

	b = ''.join(b)  ##  should work in both modes
	##  standard :
	predval = v  ##  omit if tabular
	cellvals = priorvec  ##  omit if tabular
	cellsize = priorvec[0] ; standev = priorvec[2]  ##  omit if tabular
	smalldif = priorvec[3]  ## should work in both modes
	##  tabular :
	##  retrieve cell frequencies :
	cellvals = stab[b]  ##  omit if standard
	cellsize = cellvals[0]  ##  omit if standard
	predval = cellvals[1]  ##  omit if standard
	standev = cellvals[2]  ##  omit if standard

	return ([b,predval,standev,smalldif,cellsize])
##  regression rule ends.

##  should be loadable into berries.py .

##  ending.
