##  Using BEAGLE Py template, version of 28/07/2016 :
##  rule written by plum.py ;
##  derived from ``;
##  generated on ``;
##  dumped on ``.
##
beag_gold = 5.0 ** 0.5 * 0.5 + 0.5  ##  global

import  math  ##  math library called upon

##  helper functions :
def beag_bool (v):
	##  ensures same bool/math treatment as in Beagle :
	return  (v > 0) + 0
	
def beag_exor (v1,v2):
	##  exclusive or, as in Beagle :
	return  ((v1>0) != (v2>0))

def beag_root(v):
	##  safe square root :
	if v >= 0.0:
		return  math.sqrt(v)
	else:
		return  -math.sqrt(abs(v))

def beag_slog (v):
	##  safe natural logarithm :
	if v < 0:
		return -math.log1p(abs(v))
	else:
		return  math.log1p(v)

def beag_stabprep ():
	##  sets up fallout table :
	stab = {}
	
	##  unpacks stab lines.
	
	return (stab)
	##  stabprep ends.

	
def beag_decrule (vals,stab):
	##  input vals should be an object with appropriate attribute names.
	##  target : ``
	##  rule mode is ``.

	bins = ['0','1']  ##  omit if demonic
	##  dump catlist.
	##  dump priorvec.
	##  dump subrules.
	##  compute rule values :

	p = 0 ; b = []
	while (p < subrules):
		v = (rule[p] > 0) + 0  ##  ensure numeric, omit if demonic
		b.append(bins[v])  ##  boolean string, omit if demonic
		b.append(rule[p])  ##  omit if tabular
		p = p + 1  ##  early-r, late-py

	b = ''.join(b)  ##  omit if demonic
	v = max(b) ; p = b.index(v) ; b = str(p)  ##  omit if tabular
	##  retrieve cell frequencies :
	frex = stab[b]
	cellsize = sum(frex)
	##  attenuate frex :
	cats = len(priorvec)
	slug = beag_gold / cats
	modfrex = [slug + f for f in frex]
	##  defer to Reverend Bayes :
	postvec = [priorvec[j] * modfrex[j] for j in range(cats)]
	psum = sum(postvec)
	postvec = [p / psum for p in postvec]  ##  rescale to total 1.
	m = max(postvec) ; pc = postvec.index(m)
	predcat = catlist[pc]

	return ([b,predcat,frex,postvec])
##  decision rule ends.

##  ending.
